; ==== Bsp2Ent ====
;
; ==> Project Info
; Version: v1.0
; Version date: 11/28/10
; Start date: 11/28/10
; Purpose: Ripping the entities out of a BSP file.
;
; ==> Other Info
; Developer: boe.
; Compiled using: Aut2Exe v3 (AutoIt v3.3.6.0).

#NoTrayIcon
#Include <Array.au3> ; We use this for the _ArrayPop function.
#Region
#AutoIt3Wrapper_Res_Comment=Bsp (Compiled map format) to Entity file converter for SoF2
#AutoIt3Wrapper_Res_Description=BSP to ENT file converter for SoF2
#AutoIt3Wrapper_Res_Fileversion=1.0
#AutoIt3Wrapper_Res_LegalCopyright=BoeMan (at) 1fx.uk.to
#AutoIt3Wrapper_Res_SaveSource=n
#AutoIt3Wrapper_Run_Tidy=n
#EndRegion

;$EntFile = FileOpen(@ScriptDir & "\mp_raven.bsp", 0)
$EntFile = FileOpenDialog("Select your source (BSP) file.", @ScriptDir & "\", "Maps (*.BSP)", 1) ; Let the user decide which .BSP file to convert.
If @error Then
    MsgBox(0,"Bsp2Ent v1.0", "No File chosen. Now shutting down.")
	Exit
EndIf
$EntSaveFile = FileSaveDialog("Select your destination path.", @ScriptDir & "\", "ENT files (*.ent)", 2) ; Let the user decide where to save the .ENT file. Option 2 = dialog remains until valid path/file selected
If @error Then
    MsgBox(0,"Bsp2Ent v1.0", "No valid path selected. Now shutting down.")
	Exit
EndIf
$EntContents = FileRead($EntFile) ; Read the BSPFile containing the ent data.
$Split = StringSplit($EntContents, '{' & @LF & '"', 1) ; Split the contents of the file based on { and a line feed.
$SplitSize = _ArraySize($Split) ; Store the size of the array here so we can (and will) use it later. Will save some on the resources.
$Output = FileOpen($EntSaveFile, 1) ; Open the output file in write mode.
For $i = 2 to $SplitSize - 2 ; -2 to avoid overflow and the last entity (which will include all data that the BSP stores after it).
	FileWrite($Output, "{" & @CRLF)
	$LineSplit = StringSplit($Split[$i], @LF) ; Store every line into an array. Reason we do this is so we can quickly and easily convert the line feeds into cf AND lf, so the output file should be properly readable (the line breaks anyway) into editors like notepad and others.
	For $x = 1 to _ArraySize($LineSplit) - 2
		If $x = 1 Then
			FileWrite($Output, '"')
		EndIf
		FileWrite($Output, $LineSplit[$x] & @CRLF) ; Write the line to the output file.
	Next
	;FileWrite($Output, $Split[$i]) ; If you just want to use line feeds, use this in order to speed up the process. (Do make some changes though)
Next
$Split2 = StringSplit($Split[$SplitSize-1], "}" & @LF, 1) ; Split last entity from the rest of the BSP.
$LineSplit = StringSplit($Split2[1], @LF) ; Store every line into an array. Reason we do this is so we can quickly and easily convert the line feeds into cf AND lf, so the output file should be properly readable (the line breaks anyway) into editors like notepad and others.
;FileWrite($Output, @CRLF & "}") ; If you just want to use line feeds, use this in order to speed up the process. (Do make some changes though)
FileWrite($Output, "{" & @CRLF)
For $x = 1 to _ArraySize($LineSplit) - 2
	If $x = 1 Then
		FileWrite($Output, '"')
	EndIf
	FileWrite($Output, $LineSplit[$x] & @CRLF) ; Write the line to the output file.
Next
FileWrite($Output, "}" & @CRLF) ; Write the last } to the output file (we just split with it).
FileClose($Output) ; Close the file handle.
MsgBox(0, "Bsp2Ent v1.0", ".BSP succesfully converted!" & @CRLF & "The .ENT file was created at: " & $EntSaveFile & @CRLF & @CRLF & "Found a bug? Please report at http://1fx.uk.to/" & @CRLF & "Thank you!", 180)
Exit

#cs
===========
_ArraySize{$aArray)
purpose: Getting the size of an array (couldn't quickly find a function suitable for this, and as I often use other langs, I did this myself).
by: boe
date: 11/28/10 - 8:26 PM
===========
#ce

Func _ArraySize($aArray)
	SetError(0)
	$index = 0
	Do
		$pop = _ArrayPop($aArray)
		$index = $index + 1
	Until @error = 1
	Return $index - 1
EndFunc
